import { useQuery, useQueryClient } from "@tanstack/react-query";
import { getProjectList } from "./GeneratedRequests";

export enum QueryKeys {
  ProjectList = "ProjectList",
}

export const useMutator = (apiRequest: (...args: any) => Promise<any>, invalidate: string[]) => {
  const qc = useQueryClient();
  const mutate = async (...args: any) => apiRequest(...args).then(() => qc.invalidateQueries({ queryKey: invalidate }));
  return mutate;
};

export const useProjectList = (projectId: string) =>
  useQuery({ queryKey: [QueryKeys.ProjectList], queryFn: () => getProjectList(projectId) });
